#!/usr/bin/env gnuplot

# Usage: 
#    gnuplot fitConvergence.gnuplot
# or simply
#    ./fitConvergence.gnuplot
# if the script has been made executable

set terminal pngcairo enhanced

# The function to fit
f(x) = a*x+b
# Do not write logfile, on screen is enough
set fit logfile '/dev/null'
# Do the fit
fit f(x) "results.dat" using (log($1)):(log($2)) via a,b

# Configure plot
set logscale x
set logscale y
set xlabel "Time step (log)"
set ylabel "Relative L^2 error at final time (log)"

# Function used to write the result in the legend
slopeString(s) = sprintf("fit slope: %f",s)

# Now draw the plot
set output "convergence.png"
p "results.dat" w p lw 2 lc 1 t "data points", exp(f(log(x))) w l lc 1 lw 2 t slopeString(a)


